project "BarinkEngine"
  kind "StaticLib"

  buildmessage "Building BarinkEngine"

  includedirs {
    "Include/",

    "../libs/lua/include",
    "../libs/spdlog/include",
    "../libs/glm",
    "../libs/GorillaAudio/include",

    "../libs/physx/physx/include",
    "../libs/steam-audio/include",
    "../libs/assimp/include",
    "../libs/glad/include",
    "../libs/glfw/include",
   -- "../libs/tinygltf",
    "../libs/glew/include",
    "../libs/glm",
    "../libs/ImGui",

  }

  libdirs {
    "../libs/steam-audio/lib/windows-x64",
    "../libs/lua",
    "../libs/spdlog/build/Release",
    "../libs/assimp/lib/Debug",
    "../libs/glfw/build/src/Debug",
    "../libs/ImGui"
  }

  links {
    "phonon",
    "lua54",
    "spdlog",
    "assimp-vc143-mtd",
    "glfw3"
  }

  files {
    "../libs/ImGui/*.cpp",
    "../libs/ImGui/backends/imgui_impl_glfw.cpp",
    "../libs/ImGui/backends/imgui_impl_Opengl3.cpp",
    "../libs/glad/src/glad.c",

    "./*.cpp",
    "./*.h",
    "./**/*.cpp",
    "./**/*.h"
  }



  -- NOTE: make these copy instructions more flexible
  ok, err = os.copyfile("graphics/shaders/fragment.shader", "../build/SandboxApplication/Debug/test.fs")
  if err then error("Copy fragment shader source failed!") end

  ok, err = os.copyfile("graphics/shaders/vertex.shader", "../build/SandboxApplication/Debug/test.vs")
  if err then error("Copy vertex shader source failed!") end

  ok, err = os.copyfile("graphics/shaders/RenderSurfaceFrag.shader", "../build/SandboxApplication/Debug/RenderSurface.fs")
  if err then error("Copy fragment shader source failed!") end

  ok, err = os.copyfile("graphics/shaders/RenderSurfaceVert.shader", "../build/SandboxApplication/Debug/RenderSurface.vs")
  if err then error("Copy vertex shader source failed!") end

