workspace "BarinkEngine"
	configurations { "Debug", "Test", "Release" } 

	language "C++"
	cppdialect "C++17"

	targetdir "./build/%{prj.name}/%{cfg.buildcfg}"
	objdir "./intermediates/%{prj.name}/%{cfg.buildcfg}"

	architecture "x86_64"


	filter "configurations:Debug"
			defines {"DEBUG"}
			symbols "On"

	filter "configurations:Release"
		defines {"NDEBUG"}
		optimize "On"


	project "SandboxApplication"
		kind "ConsoleApp"
		
		buildmessage "Building Sandbox ..."

		links{
			"BarinkEngine"
		}

		includedirs{
			"./BarinkEngine/Include",
	

			-- I'd prefer if didn't need these..
			-- We'll figure that out some time later
			"./libs/lua/include",
			"./libs/spdlog/include",
			"./libs/glm",
			"./libs/GorillaAudio/include",
	
			"./libs/assimp/include",
			"./libs/glad/include",
			"./libs/glfw/include",
			"./libs/tinygltf",
			"./libs/glew/include",
			"./libs/glm",
			"./libs/ImGui",
	

		}

		libdirs {
			'./build/BarinkEngine/Debug'
		}
	
		files { 
			"./SandboxApplication/*.h",
			"./SandboxApplication/*.cpp"
		}


include("./BarinkEngine")
